.586
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
include \masm32\m32lib\masm32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\m32lib\masm32.lib

.data 
align 16
  brt    dd  32 dup (0)  ; 1024 bits  the square root  really needs 1/2 bits + 1
  brm    dd  32 dup (0)  ;            the remainder
  bdd    dd  32 dup (0)  ;            the unsigned integer number
  maxrt  dd  0
  maxrm  dd  0
  maxdd  dd  0
  junk0  dd  -1  ; for debug alignment
  cursh  dd  0
  cur2b  dd  0
  done   dd  0
  junk1  dd  -1  ; for debug alignment
  currt  dd  0
  currm  dd  0
  curdd  dd  0
  junk2  dd  -1  ; for debug alignment
  szMessage db "Exact",13,10,13,10
  szResult  db 256 dup (0)
  szCaption db "Unsigned Integer Square Root",0
  szFmtStr  db "%0.8X %0.8X %0.8X %0.8Xh : Number",13,10
            db "%0.8X %0.8X %0.8X %0.8Xh : Square Root",0
  szFmtStr0 db "%lu %lu %lu %lu ",0


 ; Put the number in binary, grouping two bits together high to low 
 ; ie the byte E5 becomes the 4 pairs 11 10 01 01.  
 ; Uses 11 then 10 then 01 then 01.
 ; 
 ; root = 0
 ; remainder = 0
 ; Loop for each pair high to low
 ;    root * 2
 ;    remainder * 4 + current pair
 ;    if root < remainder
 ;      remainder - ( root + 1)
 ;      root + 2
 ;    endif
 ; endLoop
 ; root \ 2
 ; if remainder == 0
 ;   root is from a square  ie root*root == number

 ;  The unsigned integer number allocated in dwords  bdd
 ;  Will do  even number bits / 2 iterations
 ; so a 32 or 31 bit number both need 16 iterations
 ;  Gets 2 bits at a time from high to low.
 ; 
 ; regards dsouza123

.code
start:
  ;   7FFF FFFE 9EA1 DC29   (  9223372030926249001 ) 4 dd test number
  mov edi, 1
  mov [bdd+edi*4], 07FFFFFFEh
  dec edi
  mov [bdd+edi*4], 09EA1DC29h    ; 0B504F333h

  ;   FFFF FFFE 0000 0001   ( 18446744065119617025 ) 4 dd test number
 ;   mov edi, 1
 ;   mov [bdd+edi*4], 0FFFFFFFEh
 ;   dec edi
 ;   mov [bdd+edi*4], 000000001h    ; 0FFFFFFFFh

  ; 1 0000 0000 0000 0000   ( 18446744073709551616 ) 4 dd test number
 ;   mov edi, 2
 ;   mov [bdd+edi*4], 1

; find highest non zero dd in bdd and the highest bit set in that dd to cut out unneeded iterations
; initially set maxdd to 0 based count of dwords  ex 31 if bdd has 32 dd allocated
;===============================
; maxdd
;===============================
  mov maxdd, 31        
  mov done, 0
  mov edi, maxdd
  .repeat
    .if [bdd + edi*4] == 0
      .if edi > 0
         dec edi
      .else
         mov done, 1
      .endif
    .else
      mov maxdd, edi
      mov done, 1
    .endif
  .until (done == 1)

  ; mov maxdd, 3
  mov eax, maxdd
  inc eax
  shr eax, 1
  mov maxrt, eax 
  mov maxrm, eax


;===============================
; cursh
;===============================
  mov edi, maxdd
  mov curdd, edi
  mov edx, [bdd + edi*4]
  ; mov curdd, 3     ; current dword
  mov cursh, 30    ; current shift  30 shifted

  mov eax, 1
  ror eax, 2       ; set bit 30 to 1 
again_sh:
  .if eax > edx
     .if cursh > 0
        dec cursh
        dec cursh
        shr eax,2
     .endif
  .endif
  cmp eax, edx
  ja again_sh

  nop
  nop
  nop

  mov cur2b, 0     ; current pair of bits



;=================================================================================
;
; Loop for each bit pair from highest to lowest
;    root * 2
;    remainder * 4 + current pair
;    if root < remainder
;      remainder - ( root + 1)
;      root + 2
;    endif
; endLoop
;
;=================================================================================

againloop:
;===============================
; cur2b
;===============================
  mov eax, -1
  cmp curdd, eax
  je pastloop

  mov edi, curdd
  mov eax, [bdd+edi*4]
  mov ecx, cursh
  shr eax, cl
  and eax, 3
  mov cur2b, eax
  .if cursh == 0
     mov cursh, 30
     ; .if curdd <> 0   ; allow to get to ffff  -1  indicate done iterations
     dec curdd
     ; .endif
  .else
     dec cursh
     dec cursh
  .endif

;===============================
; brt * 2
;===============================
  mov edi, maxrt
again2rt:  
  mov edx, [brt + edi*4]
  mov eax, [brt + edi*4 - 4]
  shld edx, eax, 1
  mov [brt + edi*4], edx
  dec edi
  cmp edi, 0
  jbe past2rt
  jmp again2rt
past2rt:
  shl brt, 1

;7FFF FFFE 9EA1 DC29  test number
;          B504 F333  good root result

;===============================
; (brm * 4) + cur2b
;===============================
  mov edi, maxrm
again4rm:
  mov edx, [brm + edi*4]
  mov eax, [brm + edi*4 - 4]
  shld edx, eax, 2
  mov [brm + edi*4], edx
  dec edi
  cmp edi, 0
  jbe past4rm
  jmp again4rm
past4rm:
  shl brm, 2
  mov eax, cur2b  ; add current pair of bits
  add brm, eax 

;===== place marker for debugging
  nop
  mov edi, -1
  nop
;=====

;===============================
; if root < remainder
;===============================
  mov done, 0
  mov edi, maxrm
again_rt_rm:
  mov eax, [brt + edi*4]
  mov edx, [brm + edi*4]
  .if     eax == edx ; root == rem  keep checking
     .if edi > 0
        dec edi
     .else
        mov done, 4  ; last dd  still ==
     .endif
  .elseif eax > edx  ; root >  rem  done can skip routine
     mov done, 16
  .else  ;eax < edx  ; root <  rem  done must do  routine
     mov done, 1
  .endif
  cmp done, 0        ; not finished comparison
  je  again_rt_rm

  cmp done, 16       ; brt >  brm  skip   if root < remainder routine
  je  againloop

  cmp done, 4        ; brt == brm  skip   if root < remainder routine
  je  againloop

  ; cmp done, 1      ; brt <  brm  DO IT  has to be 1 so  do routine
      

;===============================
; brm - ( brt + 1 )
;===============================
  mov ebx, 1   ; stc
  mov edi, 0
  .repeat
    bt  ebx, 0 
    mov eax, [brt + edi*4]
    sbb [brm + edi*4], eax
    setc bl
    inc edi
  .until edi > maxrm

 ;    borrow := 1
 ;    for i := 0 to maxrm 
 ;      brm[i] := brm[i] - brt[i] - borrow


;===============================
; brt + 2
;===============================
  mov eax, brt
  and eax, 3
  add eax, 2
  cmp eax, 3
  ja full2rtplus
  add brt, 2
  jmp againloop

full2rtplus:  
  mov edi, 0
  xor ebx, ebx
  add [brt + edi*4], 2
  jnc past2rtplus
  setc bl
again2rtplus:
  inc edi
  bt  ebx, 0
  adc [brt + edi*4], 0
  setc bl
  jc  again2rtplus
past2rtplus:

  jmp againloop







;=================================================================================
;
; Finished iterations  only  root / 2  is left
;
;=================================================================================

pastloop:
;===============================
; brt / 2
;===============================
  mov edi, 1
again2rtdiv:  
  mov edx, [brt + edi*4]
  mov eax, [brt + edi*4 - 4]
  shrd eax, edx, 1
  mov [brt + edi*4 - 4], eax
  inc edi
  cmp edi, maxrt
  jbe again2rtdiv
past2rtdiv:
  shr [brt + edi*4 - 4], 1


 ; Loop for each pair high to low
 ;    root * 2
 ;    remainder * 4 + current pair
 ;    if root < remainder
 ;      remainder - ( root + 1)
 ;      root + 2
 ;    endif
 ; endLoop
 ;
 ; root \ 2
 ; if remainder == 0
 ;   root is from a square  ie root*root == number





;=================================================================================
;
; Output messagebox with number and square root.
; Both are in hex and only lowest 4 dd are shown.
;
;=================================================================================

gone:
  .if brm != 0
     mov dword ptr szMessage, 20202020h
     mov byte  ptr szMessage, 20h
  .endif
  invoke wsprintf, addr szResult, addr szFmtStr, [bdd+12], [bdd+8], [bdd+4], [bdd], [brt+12], [brt+8], [brt+4], [brt]
  invoke MessageBox,  NULL, addr szMessage, addr szCaption, MB_OK
  invoke ExitProcess, NULL
end start